com.microfocus.awm.model

## Interface ITaurusSystemDirectory

- All Known Implementing Classes:
    TaurusSystemDirectory

      public interface ITaurusSystemDirectory

  This interface is used to manage `ITaurusSystem`s.

  This interface handles the life cycle of `ITaurusSystem`s. It is called to add, load and remove `ITaurusSystem`s. The informations about the `ITaurusSystem`s must be saved consistently. It is intended to save and load the informations about the `ITaurusSystem`s in the st_systems.xml-file in the workspace.

  This interface is not intended to be implemented by clients.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addObserver(java.util.Observer pObserver)` add the given observer to this class
    `void` | `addSystem(ITaurusSystem pSystem, boolean pNotify)` Add the given TAURUS system to the TAURUS system directory.
    `java.util.Map<java.lang.String,java.lang.Boolean>` | `getExpandMap()` Gets the map with all resources of this system which are expanded in the tree view.
    `ITaurusSystem` | `getSelectedSystem()` Deprecated. not used anymore. The active (or "selected") system is determined by the active application.
    `ITaurusSystem` | `getTaurusSystem(java.lang.String pResourceID)` Returns the TAURUS system with the given ID.
    `ITaurusSystem` | `getTaurusSystem(java.lang.String pSystemName, java.lang.String pRemoteSysName)` Returns an `ITaurusSystem` for the given parameters or `null` if that system does not exist.
    `java.util.List<ITaurusSystem>` | `getTaurusSystemList()` Gets a list of all available AWM systems.
    `void` | `loadSystems()` Load the system directory from the st_systems.xml-file in the workspace.
    `void` | `notifyChanged(TaurusNotification pNotification)` Fires a change notification to update observers after AWM system changes.
    `void` | `removeSystem(ITaurusSystem pSystem)` Remove the given TAURUS system from the system directory.
    `void` | `saveSystems()` Save the system directory to the st_systems.xml-file in the workspace.
    `void` | `setExpandMap(java.util.Map<java.lang.String,java.lang.Boolean> pExpandMap)` Sets the map of all resources of this system which are expanded in the tree view.
    `void` | `setSelectedSystem(ITaurusSystem pTaurusSystem)` Deprecated. not used anymore. The active (or "selected") system is determined by the active application.
    `boolean` | `systemsLoaded()` Gets whether loading cached systems was completed.

- - ### Method Detail

    - #### addSystem

          void addSystem(ITaurusSystem pSystem,
                         boolean pNotify)
                  throws TaurusCoreException

      Add the given TAURUS system to the TAURUS system directory.
      Parameters:
        `pSystem` - TAURUS system to be added
        `pNotify` - if `true`, notify the system directory's observers
      Throws:
        `TaurusCoreException` - if a TAURUS System with the same name already exists.

    - #### removeSystem

          void removeSystem(ITaurusSystem pSystem)

      Remove the given TAURUS system from the system directory.
      Parameters:
        `pSystem` - TAURUS system to be removed

    - #### loadSystems

          void loadSystems()
                    throws TaurusCoreException

      Load the system directory from the st_systems.xml-file in the workspace.
      Throws:
        `TaurusCoreException` - if loading the system cache fails

    - #### saveSystems

          void saveSystems()
                    throws TaurusCoreException

      Save the system directory to the st_systems.xml-file in the workspace.
      Throws:
        `TaurusCoreException` - if saving the system cache fails

    - #### getSelectedSystem

          @Deprecated
          ITaurusSystem getSelectedSystem()

      Deprecated. not used anymore. The active (or "selected") system is determined by the active application.
      Gets the system of the application which is currently loaded.
      Returns:
        the currently active system

    - #### setSelectedSystem

          @Deprecated
          void setSelectedSystem(ITaurusSystem pTaurusSystem)

      Deprecated. not used anymore. The active (or "selected") system is determined by the active application.
      Sets the currently active system.
      Parameters:
        `pTaurusSystem` - the new active system

    - #### getTaurusSystemList

          java.util.List<ITaurusSystem> getTaurusSystemList()

      Gets a list of all available AWM systems.
      Returns:
        a list of all systems

    - #### addObserver

          void addObserver(java.util.Observer pObserver)

      add the given observer to this class
      Parameters:
        `pObserver` - observer

    - #### setExpandMap

          void setExpandMap(java.util.Map<java.lang.String,java.lang.Boolean> pExpandMap)

      Sets the map of all resources of this system which are expanded in the tree view.
      Parameters:
        `pExpandMap` - the map containing all expanded resources

    - #### getExpandMap

          java.util.Map<java.lang.String,java.lang.Boolean> getExpandMap()

      Gets the map with all resources of this system which are expanded in the tree view.
      Returns:
        a map with all expanded resources

    - #### getTaurusSystem

          ITaurusSystem getTaurusSystem(java.lang.String pSystemName,
                                        java.lang.String pRemoteSysName)

      Returns an `ITaurusSystem` for the given parameters or `null` if that system does not exist.
      Parameters:
        `pSystemName` - the name of a TAURUS System
        `pRemoteSysName` - the unique name of the remote system
      Returns:
        the TAURUS System or `null`

    - #### getTaurusSystem

          ITaurusSystem getTaurusSystem(java.lang.String pResourceID)

      Returns the TAURUS system with the given ID.
      Parameters:
        `pResourceID` - the ID of the TAURUS system (case sensitive)
      Returns:
        an `ITaurusSystem` or `null` if the system was not found or loaded from cache.
      See Also:
        `loadSystems()`

    - #### systemsLoaded

          boolean systemsLoaded()

      Gets whether loading cached systems was completed. This can be useful at startup, since loading cached systems runs in a job which waits for initializations of depending frameworks.
      Returns:
        `true` if cached AWM systems have already been loaded

    - #### notifyChanged

          void notifyChanged(TaurusNotification pNotification)

      Fires a change notification to update observers after AWM system changes.
      Parameters:
        `pNotification` - the notification

Copyright © 2015 Micro Focus GmbH. All rights reserved.